*********************************************************
*			  ""
*				  
*					 Resizer
*			    
*		.., --, olegvbru@yahoo.com
*					   27.11.04
*		   . (http://www.foxclub.ru/sol/index.php?act=view&id=426)
*		 . (http://www.foxclub.ru/sol/index.php?act=view&id=313)
*					Release 1.04 14.12.04
*********************************************************
*
#include resize.h
*
define class Resizer as custom
  nControls = 0				&&   ,    
  dimension aControls[1]	&&      .
  							&&   Prepare.
  nLinks = 0				&&    :
  dimension aLinks[1,2]		&& 1 - -, 2 -  , 3 -  .
  							&&   Prepare

* -------------     ,    -------------

procedure Prepare
*     ,   
*     ,    ,
*    ,  aControls  aLinks.
*   Init ,        .

  store 0 to this.nControls, this.nLinks
  this.PrepareControl(thisform)
  this.CheckAnchored('')

endproc

procedure PrepareControl
lParameters toControl
local loChild, lnLeft, lnRight, lnTop, lnBottom

  this.ObjToClient(toControl, @lnLeft, @lnRight, @lnTop, @lnBottom)
  with toControl
	.addproperty('nBaseLeft', lnLeft)
	.addproperty('nBaseTop', lnTop)
	.addproperty('nBaseRight', lnRight)
	.addproperty('nBaseBottom', lnBottom)

	do case
	case .BaseClass = 'Pageframe'
	  for each loPage in .Pages
		this.PrepareControl (loPage) && (loChild)
	  next loPage
	case inlist(.BaseClass, 'Form', 'Container', 'Page')
	  for each loChild in .Controls
		if this.CheckControl (loChild)
		  this.PrepareControl (loChild)
		endif
	  next loChild
	case inlist(.BaseClass, 'Commandgroup', 'Optiongroup')
	  for each loChild in .Buttons
		if this.CheckControl (loChild)
		  this.PrepareControl (loChild)
		endif
	  next loChild
	case .BaseClass = 'Grid'
	  this.SetGridLayout(toControl)
	  for each loChild in .Columns
		local lcName
		lcName = upper(substr(sys(1272, loChild), len(thisform.name) + 1))
		this.CheckAnchored(lcName)	&& ..   - ?
	  next loChild
	endcase
  endwith
endproc

function CheckControl		&&      
lParameters toControl
local lcName, loAnchor, lcAnchor, llReady
  lcName = upper(substr(sys(1272, toControl), len(thisform.name) + 1))
  llReady = .T.
  if pemstatus(toControl, 'nAnchor', 5) and;
	 not empty(toControl.nAnchor)

	*   nAnchor,  
	if vartype(toControl.nAnchor) <> T_NUMERIC
	  if vartype(toControl.nAnchor) = T_CHARACTER and;
		 type(toControl.nAnchor) = T_NUMERIC
		toControl.nAnchor = evaluate(toControl.nAnchor)
	  else
		return .T.
	  endif
	endif

	loAnchor = this.AnchorControl (toControl, @lcAnchor)
	if isnull(loAnchor)			&&     
	  this.AddControl(lcName, toControl)
	  this.SetControlLayout(toControl, null)
	  this.CheckAnchored(lcName)	&& ..   - ?
	else						&&   
	  if not pemstatus(loAnchor, 'nAnchor', 5) or;
		 empty(loAnchor.nAnchor) or;			&&     
		 aScan(this.aControls, lcAnchor) > 0	&& -   

		this.AddControl(lcName, toControl)
		this.AddLink(lcName, lcAnchor, .T.)
		this.SetControlLayout(toControl, loAnchor)
		this.CheckAnchored(lcName)	&& ..   - ?

	  else										&& -   
		this.AddLink(lcName, lcAnchor, .F.)
		llReady = .F.
	  endif
	endif

  else		&&   nAnchor
	this.CheckAnchored(lcName)	&& ..   - ?
  endif
  return llReady
endfunc

procedure CheckAnchored			&&     
lParameters tcAnchor
local lnLink, loControl, loAnchor
  llRepeat = .T.
  do while llRepeat
	llRepeat = .F.
	lnLink = 1
	do while lnLink <= this.nLinks
	  if not this.aLinks[lnLink, 3]		&&    
		loAnchor = evaluate('thisform' + this.aLinks[lnLink, 1])
		if (empty(tcAnchor) and;
		    pemstatus(loAnchor, 'IsChecked', 5) and loAnchor.IsChecked) or;
		   (this.aLinks[lnLink, 1] == tcAnchor)

		  loControl = evaluate('thisform' + this.aLinks[lnLink, 2])
		  this.AddControl (this.aLinks[lnLink, 2], loControl)
		  this.SetControlLayout(loControl, loAnchor)
		  this.aLinks[lnLink, 3] = .T.
		  this.PrepareControl(loControl)
		else
		  llRepeat = llRepeat or empty(tcAnchor)
		endif
	  endif		&& not this.aLinks[lnLink, 3]

	  lnLink = lnLink + 1
	enddo
  enddo
endproc

procedure SetControlLayout
lParameters toControl, toAnchor
*   ""  
* (      
*  )
local lnMask, lnLeft, lnRight, lnTop, lnBottom
local lnAncLeft, lnAncRight, lnAncTop, lnAncBottom
local lnLeftMrg, lnRightMrg, lnTopMrg, lnBottomMrg
  with toControl
	lnMask = this.AnchorMask(toControl, toAnchor)
	if isnull(toAnchor)
	  lnLeft = .left
	  lnRight = .left + .width
	  lnTop = .top
	  lnBottom = .top + .height
	  * lnMask  = 0 => lnAncXXX  
	else
	  this.ObjToCLient (toControl, @lnLeft, @lnRight, @lnTop, @lnBottom)
	  this.ObjToCLient (toAnchor, @lnAncLeft, @lnAncRight, @lnAncTop, @lnAncBottom)
	endif

	lnLeftMrg   = iif(bitand(lnMask, AM_Left ) = 0, .left, lnLeft - lnAncLeft)
	lnTopMrg    = iif(bitand(lnMask, AM_Top ) = 0, .top, lnTop - lnAncTop)
	lnRightMrg  = iif(bitand(lnMask, AM_Right ) = 0,;
					  iif(.parent.BaseClass = 'Page', .parent.parent.PageWidth, .parent.width) - (.left + .width),;
					  lnAncRight - lnRight)
	lnBottomMrg = iif(bitand(lnMask, AM_Bottom ) = 0,;
					  iif(.parent.BaseClass = 'Page', .parent.parent.PageHeight, .parent.height) - (.top + .height),;
					  lnAncBottom - lnBottom)

    .addproperty('nLeftMargin', lnLeftMrg)
    .addproperty('nTopMargin', lnTopMrg)
	.addproperty('nRightMargin', lnRightMrg)
	.addproperty('nBottomMargin', lnBottomMrg)
  endwith
endproc

function AnchorControl
lParameters toControl, tcName
local lcAnchor, loAnchor, lcControl
*    -   toControl  null
* -   toControl.cAnchorControl .. 
* 1)   (  thisform) - thisform.Container1.Command1
* 2)    (  this) - this.parent.Command1
* 3)    - Command1
*       ,     -    
*   tcName,    
  loAnchor = null
  if pemstatus(toControl, 'cAnchorControl', 5) and;
  	 not empty(toControl.cAnchorControl)
	lcAnchor = upper(toControl.cAnchorControl)
	lcControl = strtran( upper(sys(1272, toControl)), upper(thisform.name), 'THISFORM')
    if left(lcAnchor, 4) = 'THIS'
	  if left(lcAnchor, 11) = 'THIS.PARENT'
		lcAnchor = lcControl + substr(lcAnchor, 5)
	  endif
	else
	  lcAnchor = forceext(lcControl, lcAnchor)
	endif

	if type(lcAnchor) = T_OBJECT
	  loAnchor = evaluate(lcAnchor)
	  if pcount() = 2
		tcName = substr(lcAnchor, 9)
	  endif
	else
	  toControl.cAnchorControl = ''
	endif
  endif
  return loAnchor
endfunc

function AnchorMask			&&     /-
lParameters toControl, toAnchor
local lnMask
  lnMask = 0
  if not isnull(toAnchor)
	lnMask = 15
	if pemstatus(toControl, 'nAnchorMask', 5) and;
	   not empty(toControl.nAnchorMask)
	  lnMask = toControl.nAnchorMask
	endif
  endif
  return lnMask
endfunc

procedure AddControl
lParameters tcName, toControl
  this.nControls = this.nControls + 1
  dimension this.aControls[this.nControls, 1]
  this.aControls[this.nControls, 1] = tcName
  toControl.AddProperty('IsChecked', .T.)
endproc

procedure AddLink
lparameter tcControl, tcAnchor, tlCheck
  this.nLinks = this.nLinks + 1
  dimension this.aLinks[this.nLinks, 3]
  this.aLinks[this.nLinks, 1] = tcAnchor
  this.aLinks[this.nLinks, 2] = tcControl
  this.aLinks[this.nLinks, 3] = tlCheck
endproc

* -------------      ---------------- *

procedure Resize
lparameters toControl
local lcName, lnItem, lnLink, loControl, lcControl, llLockScreen
  if not thisform.LockScreen
	thisform.LockScreen = .T.
	llLockScreen = .T.
  endif

  lcName = iif(pcount() = 0, '',;
  			   upper(substr(sys(1272, toControl), len(thisform.name) + 1)))

  for lnLink = 1 to this.nLinks
	this.aLinks[lnLink, 3] = .F.		&&     
  next lnLink

  for lnItem = 1 to this.nControls

	lcControl = this.aControls[lnItem]

	*  toControl ,      !
	if empty(lcName) or left(lcControl, len(lcName)) == lcName
	  if type('thisform' + lcControl) = T_OBJECT
		this.ResizeControl (evaluate('thisform' + lcControl))
		*    ,       
		for lnLink = 1 to this.nLinks
		  if this.aLinks[lnLink, 2] == lcControl
			this.aLinks[lnLink, 3] = .T.		&&  
		  endif
		next lnLink
	  endif
	endif
  next lnItem

  if not empty(lcName)
	*       
	*  ,   toControl   
	for lnLink = 1 to this.nLinks
	  if lcName == left(this.aLinks[lnLink, 1], len(lcName)) and;
		 not this.aLinks[lnLink, 3]

		lcControl = 'thisform' + this.aLinks[lnLink, 2]
		if type(lcControl) = T_OBJECT
		  this.Resize (evaluate(lcControl))
		endif
	  endif
	next lnLink
  endif

  if llLockScreen
	thisform.LockScreen = .F.
  endif
endproc

procedure ResizeControl
lparameters toControl
*      
*       nAnchor
*   /    toControl
*     ,    nAnchor
*  (  ),     
*  Left, Top, Width, Height   Move
  local loAnchor, lnMask, lnBaseWidth, lnBaseHeight, lnCoef
  local lnParentLeft, lnParentRight, lnParentTop, lnParentBottom
  local lnAnchorLeft, lnAnchorRight, lnAnchorWidth, lnAnchorTop, lnAnchorBottom, lnAnchorHeight
  local lnLeftMargin, lnRightMargin, lnTopMargin, lnBottomMargin
  local lnLeft, lnTop, lnWidth, lnHeight

  with toControl

	loAnchor = this.AnchorControl(toControl)
	lnMask = this.AnchorMask(toControl, loAnchor)

	this.ObjToClient(.parent, @lnParentLeft, @lnParentRight, @lnParentTop, @lnParentBottom)
	if isnull(loAnchor)
	  lnBaseWidth = .parent.nBaseRight - .parent.nBaseLeft
	  lnBaseHeight = .parent.nBaseBottom - .parent.nBaseTop
	else
	  this.ObjToClient(loAnchor, @lnAnchorLeft, @lnAnchorRight, @lnAnchorTop, @lnAnchorBottom)
	  lnBaseWidth = iif(bitand(lnMask, AM_Right) = 0, .parent.nBaseRight, loAnchor.nBaseRight) -;
	  				iif(bitand(lnMask, AM_Left) = 0, .parent.nBaseLeft, loAnchor.nBaseLeft)
	  lnBaseHeight = iif(bitand(lnMask, AM_Bottom) = 0, .parent.nBaseBottom, loAnchor.nBaseBottom) -;
	  				 iif(bitand(lnMask, AM_Top) = 0, .parent.nBaseTop, loAnchor.nBaseTop)
	endif

	lnAnchorLeft  = iif(bitand(lnMask, AM_Left) = 0, lnParentLeft, lnAnchorLeft)
	lnAnchorRight = iif(bitand(lnMask, AM_Right) = 0, lnParentRight, lnAnchorRight)
	lnAnchorWidth = lnAnchorRight - lnAnchorLeft

	lnAnchorTop    = iif(bitand(lnMask, AM_Top) = 0, lnParentTop, lnAnchorTop)
	lnAnchorBottom = iif(bitand(lnMask, AM_Bottom) = 0, lnParentBottom, lnAnchorBottom)
	lnAnchorHeight  = lnAnchorBottom - lnAnchorTop

	* 
	store .F. to lnLeftMargin, lnRightMargin
	lnCoef = iif(lnBaseWidth = 0, 1, lnAnchorWidth / lnBaseWidth)

	if bitand(.nAnchor, AM_Left) <> 0		&&   
	  lnLeftMargin = .nLeftMargin
	endif
	if bitand(.nAnchor, AM_Right) <> 0		&&   
	  lnRightMargin = .nRightMargin
	endif
	if bitand(.nAnchor, AM_LeftRel) <> 0	&&    
	  lnLeftMargin = .nLeftMargin * lnCoef
	endif
	if bitand(.nAnchor, AM_RightRel) <> 0	&&    
	  lnRightMargin = .nRightMargin * lnCoef
	endif
	if bitand(.nAnchor, AM_LeftDock) <> 0	&&   = 0
	  lnLeftMargin = 0
	endif
	if bitand(.nAnchor, AM_RightDock) <> 0	&&   = 0
	  lnRightMargin = 0
	endif
	if bitand(.nAnchor, AM_HorCenter) <> 0	&& 
	  lnLeftMargin = (lnAnchorWidth - .width) / 2
	endif
	  
	* 
	store .F. to lnTopMargin, lnBottomMargin
	lnCoef = iif(lnBaseHeight = 0, 1, lnAnchorHeight / lnBaseHeight)

	if bitand(.nAnchor, AM_Top) <> 0		&&   
	  lnTopMargin = .nTopMargin
	endif
	if bitand(.nAnchor, AM_Bottom) <> 0		&&   
	  lnBottomMargin = .nBottomMargin
	endif
	if bitand(.nAnchor, AM_TopRel) <> 0		&&    
	  lnTopMargin = .nTopMargin * lnCoef
	endif
	if bitand(.nAnchor, AM_BottomRel) <> 0	&&    
	  lnBottomMargin = .nBottomMargin * lnCoef
	endif
	if bitand(.nAnchor, AM_TopDock) <> 0	&&   = 0
	  lnTopMargin = 0
	endif
	if bitand(.nAnchor, AM_BottomDock) <> 0	&&   = 0
	  lnBottomMargin = 0
	endif
	if bitand(.nAnchor, AM_VerCenter) <> 0	&& 
	  lnTopMargin = (lnAnchorHeight - .height) / 2
	endif
	  
	lnLeft = .left
	lnWidth = .width
	lnTop  = .top
	lnHeight = .height

	do case
	case vartype(lnLeftMargin) = T_NUMERIC and vartype(lnRightMargin) = T_NUMERIC
	  lnLeft = lnAnchorLeft + lnLeftMargin - lnParentLeft
	  lnWidth = lnAnchorWidth - (lnLeftMargin + lnRightMargin)
	case vartype(lnLeftMargin) = T_NUMERIC and vartype(lnRightMargin) = T_LOGICAL
	  lnLeft = lnAnchorLeft + lnLeftMargin - lnParentLeft
	case vartype(lnLeftMargin) = T_LOGICAL and vartype(lnRightMargin) = T_NUMERIC
	  lnLeft = lnAnchorLeft + lnAnchorWidth - (lnParentLeft + .width + lnRightMargin)
	endcase

	do case
	case vartype(lnTopMargin) = T_NUMERIC and vartype(lnBottomMargin) = T_NUMERIC
	  lnTop = lnAnchorTop + lnTopMargin - lnParentTop
	  lnHeight = lnAnchorHeight - (lnTopMargin + lnBottomMargin)
	case vartype(lnTopMargin) = T_NUMERIC and vartype(lnBottomMargin) = T_LOGICAL
	  lnTop = lnAnchorTop + lnTopMargin - lnParentTop
	case vartype(lnTopMargin) = T_LOGICAL and vartype(lnBottomMargin) = T_NUMERIC
	  lnTop = lnAnchorTop + lnAnchorHeight - (lnParentTop + .height + lnBottomMargin)
	endcase

	if lnLeft <> .left or lnTop <> .top or lnWidth <> .width or lnHeight <> .height
	  local lnMin, lnMax
	  lnMin = iif(pemstatus(toControl, 'nMinWidth', 5), .nMinWidth,;
	  		  iif(.BaseClass = 'Grid', 20, 0))
	  lnMax = iif(pemstatus(toControl, 'nMaxWidth', 5), .nMaxWidth, 10000)
	  lnWidth = max(min(lnWidth, lnMax), lnMin)

	  lnMin = iif(pemstatus(toControl, 'nMinHeight', 5), .nMinHeight,;
	  		  iif(inlist(.BaseClass, 'Grid', 'Pageframe'), 25, 0))
	  lnMax = iif(pemstatus(toControl, 'nMaxHeight', 5), .nMaxHeight, 10000)
	  lnHeight = max(min(lnHeight, lnMax), lnMin)

	  .move(lnLeft, lnTop, lnWidth, lnHeight)
	endif

	if .BaseClass = 'Grid'
	  this.GridResize(toControl)
	endif

  endwith
endproc


* --------    Grid -------------

procedure SetGridLayout		&&     Grid
lParameters toGrid
local lnItem, lnWidColNRS, lnCntColNRS, lnWidth
local lnLeft, lnRight
  with toGrid

	store 0 to lnCntColNRS, lnWidColNRS	&& -      
	lnLeft = this.GridConstWidth(toGrid)
	lnRight = this.GridConstWidth(toGrid, .T.) - lnLeft
	for lnItem = 1 to .ColumnCount
	  with .Columns(lnItem)
		if not .Resizable
		  lnWidColNRS = lnWidColNRS + .width
		  lnCntColNRS = lnCntColNRS + 1
		endif
		.addproperty('nBaseLeft', lnLeft)
		lnLeft = lnLeft + .width + iif(.parent.GridLines > 1, .parent.GridLineWidth, 0)
		.addproperty('nBaseRight', lnRight - .width)
		lnRight = lnRight - .width - iif(.parent.GridLines > 1, .parent.GridLineWidth, 0)
		.addproperty('nBaseTop', .parent.HeaderHeight)
		.addproperty('nBaseBottom', 0)
	  endwith
	next lnItem

	if .ColumnCount > lnCntColNRS
	  lnWidth = .Width - this.GridConstWidth(toGrid, .T.) - lnWidColNRS

	  for lnItem = 1 to .ColumnCount
		with .Columns(lnItem)
		  if .Resizable
			.AddProperty('nBaseCoef', .width / lnWidth)
		  endif
		endwith
	  next lnItem
	endif
  endwith
endproc

procedure GridResize	&&      Grid
lParameters toGrid
*   Resizable=.F. -   ,
*   Resizable=.T.    
local lnItem, lnWidColNRS, lnCntColNRS, lnWidth, lnTail, lnLastCol
  with toGrid

	store 0 to lnCntColNRS, lnWidColNRS	&& -      
	for lnItem = 1 to .ColumnCount
	  with .Columns(lnItem)
		if not .Resizable
		  lnWidColNRS = lnWidColNRS + .width
		  lnCntColNRS = lnCntColNRS + 1
		endif
	  endwith
	next lnItem

	if .ColumnCount > lnCntColNRS
	  lnWidth = .Width - this.GridConstWidth(toGrid, .T.) - lnWidColNRS - 1
	  lnTail = lnWidth
	  lnLastCol = 0
	  for lnItem = 1 to .ColumnCount
		with .Columns(lnItem)
		  if .Resizable
			.width = lnWidth * .nBaseCoef
			lnTail = lnTail - .width
			lnLastCol = lnItem
		  endif
		endwith
	  next lnItem
	  .Columns(lnLastCol).width = .Columns(lnLastCol).width + lnTail
	endif

  endwith
endproc

*    Grid
*   
#Define DeleteMarkWidth 8
#Define RecordMarkWidth 10
#Define ScrollBarWidth 21

function GridConstWidth
lParameters toGrid, tlFull
  with toGrid
	return iif(.DeleteMark, DeleteMarkWidth, 0) +;
		   iif(.RecordMark, RecordMarkWidth, 0) +;
		   iif(.GridLines > 1, .GridLineWidth, 0) +;
		   iif(tlFull, iif(.ScrollBars > 1, ScrollBarWidth, 0) +;
					   iif(.GridLines > 1, .GridLineWidth * .ColumnCount, 0),;
					   0)
  endwith
endfunc

* ------------  -----------------

procedure ObjToClient		&&      
*      ..:
* 1)         PageFrame  Init 
* 2)        _screen,     0
* 3)       Resize    ,
*         ,      !!!
* 4)        
lParameters toControl, tnLeft, tnRight, tnTop, tnBottom
local loControl, lnItem

  store 0 to tnLeft, tnRight, tnTop, tnBottom
  loControl = toControl
  do while not loControl.Baseclass == 'Form'
	with loControl
	  do case
	  case .BaseClass == 'Page'
		tnLeft = tnLeft + 1
		tnTop = tnTop + .parent.height - .parent.pageheight - 2
	  case .BaseClass == 'Column'
		tnLeft = tnLeft + this.GridConstWidth(.parent)
		for lnItem = 1 to .parent.ColumnCount
		  if .parent.Columns(lnItem).ColumnOrder < .ColumnOrder
			tnLeft = tnLeft + .parent.Columns(lnItem).width + .parent.GridLineWidth
		  endif
		next lnItem
		tnTop = tnTop + .parent.HeaderHeight
	  otherwise
		tnLeft = tnLeft + .left
		tnTop = tnTop + .top
	  endcase
	endwith

	loControl = loControl.parent
  enddo
  
  with toControl
	do case
	case .Baseclass == 'Form'
	  tnRight = .width
	  tnBottom = .height
	case .BaseClass == 'Page'
	  tnRight = tnLeft + .parent.PageWidth
	  tnBottom = tnTop + .parent.PageHeight
	case .BaseClass == 'Column'
	  tnRight = tnLeft + .width
	  tnBottom = tnTop + .parent.height - .parent.HeaderHeight
	otherwise
	  tnRight = tnLeft + .width
	  tnBottom = tnTop + .height
	endcase
  endwith

endproc

procedure Release
  release this
endproc

procedure View
acti scre
*clea
?
?'-----------------------'
with this
  for i=1 to .nControls
	?.aControls[i]
  next i
?
  for i=1 to .nLinks
	?.aLinks[i,1], '->', .aLinks[i,2], .aLinks[i,3]
  next i
endwith

enddefine
